'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.matchImageSnapshotPlugin = matchImageSnapshotPlugin;
exports.addMatchImageSnapshotPlugin = addMatchImageSnapshotPlugin;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Copyright (c) 2018-present The Palmer Group
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

const fs = require('fs');
const path = require('path');
const childProcess = require('child_process');
const {
  diffImageToSnapshot
} = require('jest-image-snapshot/src/diff-snapshot');

function matchImageSnapshotPlugin(_ref) {
  let {
    fileName,
    screenshotsFolder,
    fileServerFolder,
    updateSnapshots,
    options: {
      failureThreshold = 0,
      failureThresholdType = 'pixel'
    } = {}
  } = _ref,
      options = _objectWithoutProperties(_ref.options, ['failureThreshold', 'failureThresholdType']);

  const snapshotPath = path.join(screenshotsFolder, `${fileName}.png`);
  const receivedImageBuffer = fs.readFileSync(snapshotPath);

  const result = diffImageToSnapshot(_extends({
    snapshotsDir: path.join(fileServerFolder, 'cypress', 'snapshots'),
    updateSnapshot: updateSnapshots,
    receivedImageBuffer,
    snapshotIdentifier: fileName,
    failureThreshold,
    failureThresholdType
  }, options));

  childProcess.spawnSync('cp', [result.diffOutputPath, snapshotPath]);

  return result;
}

function addMatchImageSnapshotPlugin(on) {
  on('task', { matchImageSnapshot: matchImageSnapshotPlugin });
}